#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/io.h>
#include <sys/time.h>

#define LPT 0x378


extern int ioperm();

static long long t_old = 0LL;
static int loop_prt = 100;
static int test_loops = 0;

static void print_time (int p)
{
  struct timeval tv;
  struct timezone tz;
  long long t;

  gettimeofday (&tv, &tz);
  t = tv.tv_sec * 1000000 + tv.tv_usec;

  if (p)
	  printf ("loop= %d dt= %ld ns\n", test_loops, (long)(t-t_old));
  t_old = t;
}

int main(int argc, char **argv)
{

  setuid(0);

  if (ioperm(LPT, 1, 1) < 0) {
    perror("ioperm()"); 
    exit(-1);
  }

  //print_time(0);

  while(1) {
    outb(0x01, LPT);
    usleep(50000);

    //    if (test_loops % 100 == 0)
    //      print_time(0);

    outb(0x00, LPT);
    usleep(50000);

    //    if (test_loops % 100 == 0) 
    //      print_time(1);
    
    test_loops++;
  }
  
  return(0);
}
