#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>

/* ioctl cmds */
#define SET_MODE 0
#define GET_MODE 1

main (int ac, char **av)
{
  int arg, fd, n, i;

  fd = open (av[1], O_RDWR);

  if (fd < 0) {
    perror ("open");
    exit (1);
  }

  for (i = 1 ; i < 4 ; i++) {
    printf ("setting mode= %d\n", i);
    if ((n = ioctl (fd, SET_MODE, i)) < 0)
      perror ("ioctl");

    if ((n = ioctl (fd, GET_MODE, &arg)) < 0)
      perror ("ioctl");
    else
      printf ("arg= %d\n", arg);
  }

  close (fd);
}
      
