#include <linux/module.h> 
#include <linux/kernel.h> /* Pour KERN_INFO */

MODULE_LICENSE("GPL");

static int __init hello_init(void)
{
  printk(KERN_INFO "Hello World\n");
  return 0;
}

static void __exit hello_exit(void)
{
  printk(KERN_INFO "Goodbye, cruel world!\n");
}

module_init(hello_init);
module_exit(hello_exit);
