#include <linux/module.h> 
#include <linux/kernel.h> /* Pour KERN_INFO */

MODULE_DESCRIPTION("Hello World module");
MODULE_AUTHOR("Pierre Ficheux, Open Wide");
MODULE_LICENSE("GPL");

void my_printk (char *);

static int __init hello_init(void)
{
  my_printk ("Hello World\n");
  return 0;
}

static void __exit hello_exit(void)
{
  my_printk ("Goodbye, cruel world!\n");
}

module_init(hello_init);
module_exit(hello_exit);
