#include <linux/module.h> 
#include <linux/kernel.h> /* Pour KERN_INFO */

MODULE_DESCRIPTION("my_printk module");
MODULE_AUTHOR("Pierre Ficheux, Open Wide");
MODULE_LICENSE("GPL");

void my_printk (char *s)
{
  printk (KERN_INFO "my_printk: %s\n", s);
}

EXPORT_SYMBOL_GPL (my_printk);

static int __init my_printk_init(void)
{
  my_printk ("my_printk loaded!");
  return 0;
}

static void __exit my_printk_exit(void)
{
  my_printk ("my_printk unloaded!");
}

module_init(my_printk_init);
module_exit(my_printk_exit);
